package cg4java;

/*
 * Native Implementierung der Cg Core Runtime Library
 * durch das Java Native Interface.
 */

public class CgFuncJNI implements CgFunc
{

  static
  {
    System.loadLibrary( "Cg4Java" );
  }

  /*******************************************************************/
  /*** Cg Context Functions                                       ****/
  /*******************************************************************/

  /*
   * CGDLL_API CGcontext cgCreateContext(void);
   */
  public native int cgCreateContext();

  /*
   * CGDLL_API void cgDestroyContext(CGcontext ctx);
   */
  public native void cgDestroyContext( int context );

  /*
   * CGDLL_API CGbool cgIsContext(CGcontext ctx);
   */
  public native int cgIsContext( int context );

  /*
   * CGDLL_API const char *cgGetLastListing(CGcontext ctx);
   */
  public native String cgGetLastListing( int context );

  /*******************************************************************/
  /*** Cg Program Functions                                       ****/
  /*******************************************************************/

  /*
   * CGDLL_API CGprogram cgCreateProgram(CGcontext ctx,
   *                                     CGenum program_type,
   *                                     const char *program,
   *                                     CGprofile profile,
   *                                     const char *entry,
   *                                     const char **args);
   */
  public native int cgCreateProgram( int context,
                                     int program_type,
                                     String program,
                                     int profile,
                                     String entry,
                                     String args[] );

  /*
   * CGDLL_API CGprogram cgCreateProgramFromFile(CGcontext ctx,
   *                                             CGenum program_type,
   *                                             const char *program_file,
   *                                             CGprofile profile,
   *                                             const char *entry,
   *                                             const char **args);
   */
  public native int cgCreateProgramFromFile( int context,
                                             int program_type,
                                             String program_file,
                                             int profile,
                                             String entry,
                                             String args[] );

  /*
   * CGDLL_API CGprogram cgCopyProgram(CGprogram program);
   */
  public native int cgCopyProgram( int program );

  /*
   * CGDLL_API void cgDestroyProgram(CGprogram program);
   */
  public native void cgDestroyProgram( int program );

  /*
   * CGDLL_API CGprogram cgGetFirstProgram(CGcontext ctx);
   */
  public native int cgGetFirstProgram( int context );

  /*
   * CGDLL_API CGprogram cgGetNextProgram(CGprogram current);
   */
  public native int cgGetNextProgram( int current );

  /*
   * CGDLL_API CGcontext cgGetProgramContext(CGprogram prog);
   */
  public native int cgGetProgramContext( int program );

  /*
   * GDLL_API CGbool cgIsProgram(CGprogram program);
   */
  public native int cgIsProgram( int program );

  /*
   * CGDLL_API void cgCompileProgram(CGprogram program);
   */
  public native void cgCompileProgram( int program );

  /*
   * CGDLL_API CGbool cgIsProgramCompiled(CGprogram program);
   */
  public native int cgIsProgramCompiled( int program );

  /*
   * CGDLL_API const char *cgGetProgramString(CGprogram prog, CGenum pname);
   */
  public native String cgGetProgramString( int program, int pname );

  /*
   * CGDLL_API CGprofile cgGetProgramProfile(CGprogram prog);
   */
  public native int cgGetProgramProfile( int program );

  /*******************************************************************/
  /*** Cg Parameter Functions                                     ****/
  /*******************************************************************/

  /*
   * CGDLL_API CGparameter cgGetNamedParameter(CGprogram prog, const char *name);
   */
  public native int cgGetNamedParameter( int program, String name );

  /*
   * CGDLL_API CGparameter cgGetFirstParameter(CGprogram prog, CGenum name_space);
   */
  public native int cgGetFirstParameter( int program, int name_space );

  /*
   * CGDLL_API CGparameter cgGetNextParameter(CGparameter current);
   */
  public native int cgGetNextParameter( int current );

  /*
   * CGDLL_API CGparameter cgGetFirstLeafParameter(CGprogram prog, CGenum name_space);
   */
  public native int cgGetFirstLeafParameter( int program, int name_space );

  /*
   * CGDLL_API CGparameter cgGetNextLeafParameter(CGparameter current);
   */
  public native int cgGetNextLeafParameter( int current );

  /*
   * CGDLL_API CGparameter cgGetFirstStructParameter(CGparameter param);
   */
  public native int cgGetFirstStructParameter( int param );

  /*
   * CGDLL_API CGparameter cgGetFirstDependentParameter(CGparameter param);
   */
  public native int cgGetFirstDependentParameter( int param );

  /*
   * GDLL_API CGparameter cgGetArrayParameter(CGparameter aparam, int index);
   */
  public native int cgGetArrayParameter( int param, int index );

  /*
   * CGDLL_API int cgGetArrayDimension(CGparameter param);
   */
  public native int cgGetArrayDimension( int param );

  /*
   * CGDLL_API int cgGetArraySize(CGparameter param, int dimension);
   */
  public native int cgGetArraySize( int param, int dimension );

  /*
   * CGDLL_API CGprogram cgGetParameterProgram(CGparameter prog);
   */
  public native int cgGetParameterProgram( int program );

  /*
   * CGDLL_API CGbool cgIsParameter(CGparameter param);
   */
  public native int cgIsParameter( int param );

  /*
   * CGDLL_API const char *cgGetParameterName(CGparameter param);
   */
  public native String cgGetParameterName( int param );

  /*
   * CGDLL_API CGtype cgGetParameterType(CGparameter param);
   */
  public native int cgGetParameterType( int param );

  /*
   * CGDLL_API const char *cgGetParameterSemantic(CGparameter param);
   */
  public native String cgGetParameterSemantic( int param );

  /*
   * CGDLL_API CGresource cgGetParameterResource(CGparameter param);
   */
  public native int cgGetParameterResource( int param );

  /*
   * CGDLL_API CGresource cgGetParameterBaseResource(CGparameter param);
   */
  public native int cgGetParameterBaseResource( int param );

  /*
   * CGDLL_API unsigned long cgGetParameterResourceIndex(CGparameter param);
   */
  public native int cgGetParameterResourceIndex( int param );

  /*
   * CGDLL_API CGenum cgGetParameterVariability(CGparameter param);
   */
  public native int cgGetParameterVariability( int param );

  /*
   * CGDLL_API CGenum cgGetParameterDirection(CGparameter param);
   */
  public native int cgGetParameterDirection( int param );

  /*
   * CGDLL_API CGbool cgIsParameterReferenced(CGparameter param);
   */
  public native int cgIsParameterReferenced( int param );

  /*
   * CGDLL_API const double *cgGetParameterValues(CGparameter param,
   *                                              CGenum value_type,
   *                                              int *nvalues);
   */
  public native double[] cgGetParameterValues( int param, int value_type, int nvalues );

  /*
   * CGDLL_API int cgGetParameterOrdinalNumber(CGparameter param);
   */
  public native int cgGetParameterOrdinalNumber( int param );

  /*******************************************************************/
  /*** Cg Type Functions                                          ****/
  /*******************************************************************/

  /*
   * CGDLL_API const char *cgGetTypeString(CGtype type);
   */
  public native String cgGetTypeString( int type );

  /*
   * CGDLL_API CGtype cgGetType(const char *type_string);
   */
  public native int cgGetType( String type_string );

  /*******************************************************************/
  /*** Cg Resource Functions                                      ****/
  /*******************************************************************/

  /*
   * CGDLL_API const char *cgGetResourceString(CGresource resource);
   */
  public native String cgGetResourceString( int resource );

  /*
   * CGDLL_API CGresource cgGetResource(const char *resource_string);
   */
  public native int cgGetResource( String resource_string );

  /*******************************************************************/
  /*** Cg Profile Functions                                       ****/
  /*******************************************************************/

  /*
   * CGDLL_API const char *cgGetProfileString(CGprofile profile);
   */
  public native String cgGetProfileString( int profile );

  /*
   * CGDLL_API CGprofile cgGetProfile(const char *profile_string);
   */
  public native int cgGetProfile( String profile_string );

  /*******************************************************************/
  /*** Cg Error Functions                                         ****/
  /*******************************************************************/

  /*
   * CGDLL_API CGerror cgGetError(void);
   */
  public native int cgGetError();

  /*
   * CGDLL_API const char *cgGetErrorString(CGerror error);
   */
  public native String cgGetErrorString( int error );

  /*
   * CGDLL_API void cgSetErrorCallback(CGerrorCallbackFunc func);
   */
  public native void cgSetErrorCallback( int func );

  /*
   * CGDLL_API CGerrorCallbackFunc cgGetErrorCallback(void);
   */
  public native int cgGetErrorCallback();

}
