package vsl.dataflow;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
 * Basisklasse fr alle grafischen Elemente eines Datenflussdiagramms.
 */
public abstract class DataFlowComponent extends JComponent
{

  /*
   * mgliche Ausprgungen
   */
  public static final int DF_NODE = 0;
  public static final int DF_ANCHOR = 1;
  public static final int DF_DIAGRAM = 2;
  public static final int DF_EDGE = 3;
  public static final int DF_LABEL = 4;
  public static final int DF_OTHER = 5;

  public DataFlowComponent()
  {
    super();
  }

  public void paint( Graphics g )
  {
    super.paint(g);
  }

  /*
   * Gibt wahr zurck, falls Komponente auswhlbar.
   */
  public abstract boolean isSelectable();

  /*
   * Gibt wahr zurck, falls Komponente per Maus verschiebbar.
   */
  public abstract boolean isDraggable();

  /*
   * Gibt den Komponententyp zurck.
   */
  public abstract int getComponentType();

}