package vsl.dataflow;

import java.awt.*;

import vsl.lang.DataType;
import vsl.lang.DataValue;

import org.w3c.dom.*;

public class DataFlowDestinationAnchor extends DataFlowAnchor
{
  protected DataFlowEdge edge = null;

  public DataFlowDestinationAnchor( Element element, DataFlowNode node )
  {
    super( element, node );
    String s = element.getAttribute( "default" );
    if ( !s.equals( "" ) )
    {
      defaultValue = new DataValue( type, s );
    }
    else
    {
      defaultValue = type.getDefaultValue();
    }
  }

  public DataFlowDestinationAnchor( String name, DataType type, DataFlowNode node )
  {
    super( name, type, node );
  }

  public DataFlowDestinationAnchor( String name, DataType type, DataValue defaultValue,
                                    DataFlowNode node )
  {
    super( name, type, node );
    this.defaultValue = defaultValue;
  }

  public DataFlowEdge getEdge()
  {
    return edge;
  }

  public void setEdge( DataFlowEdge edge )
  {
    this.edge = edge;
  }

  public void setLocation( Point p )
  {
    setLocation( p.x, p.y );
  }

  public void setLocation( int x, int y )
  {
    super.setLocation( x, y );
    anchorPoint = new Point( getX() - 1, getY() + getHeight() / 2 );
    label.setLocation( getX() - label.getWidth() - 2,
                       getY() + getHeight() / 2 - label.getHeight() - 2 );
    if( edge != null ) edge.update();
  }

  public void disconnect()
  {
    edge = null;
  }

  public boolean isConnected()
  {
    if ( edge == null )
    {
      return false;
    }
    else
    {
      return true;
    }
  }

  public int getAnchorType()
  {
    return DF_DESTINATION_ANCHOR;
  }

}