package vsl.dataflow;

import java.awt.Color;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.font.FontRenderContext;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.Rectangle;

import java.awt.geom.Rectangle2D;


public class DataFlowLabel extends DataFlowComponent
{

  public Color color = Color.BLACK;

  public static Font font;
  public static FontMetrics fontMetrics;

  protected String string;

  public DataFlowLabel( String string )
  {
    this.string = string;
    font = new Font( "SansSerif", Font.BOLD, 10 );
    fontMetrics = getFontMetrics(font);
    Rectangle2D rectangle = fontMetrics.getStringBounds( string, getGraphics() );
    setSize( ( int ) rectangle.getWidth(), ( int ) rectangle.getHeight() );
  }

  public void paint( Graphics graphics )
  {
    graphics.setColor( color );
    graphics.setFont( font );
    graphics.drawString( string, 0, getHeight() - 2  );
  }

  public void setFont( Font font, Graphics g )
  {
    this.font = font;
    Rectangle2D rectangle = fontMetrics.getStringBounds( string, g );
    setSize( ( int ) rectangle.getWidth(), ( int ) rectangle.getHeight() );
  }

  public int getFontSize()
  {
    return font.getSize();
  }

  public boolean isResizable()
  {
    return false;
  }

  public boolean isConnectable()
  {
    return false;
  }

  public boolean isDestination()
  {
    return false;
  }

  public boolean isDraggable()
  {
    return false;
  }

  public boolean isSource()
  {
    return false;
  }

  public boolean isSelectable()
  {
    return false;
  }

  public int getComponentType()
  {
    return DF_LABEL;
  }


}