package vsl.gui;

import java.awt.event.ActionListener;

import javax.swing.JComboBox;
import javax.swing.JTabbedPane;

import vsl.lang.DataType;

/*
 * GUI-Komponente um einen Datentyp auszuwhlen.
 */
public class DataTypeSelector extends JTabbedPane
{

  /*
   * Auswahlboxen fr einfache-, Vektor- und Matrix-Datentypen.
   */
  JComboBox elementalComboBox;
  JComboBox vectorComboBox;
  JComboBox matrixComboBox;

  /*
   * Konstruktor.
   */
  public DataTypeSelector()
  {
    elementalComboBox = new JComboBox( DataType.getElementalDataTypes() );
    vectorComboBox = new JComboBox( DataType.getVectorDataTypes() );
    matrixComboBox = new JComboBox( DataType.getMatrixDataTypes() );

    addTab("Elemental", elementalComboBox);
    addTab("Vector", vectorComboBox);
    addTab("Matrix", matrixComboBox);
  }

  /*
   * Gibt den ausgewhlten Datentyp zurck.
   */
  public DataType getDataType()
  {
    return (DataType)(((JComboBox)getSelectedComponent()).getSelectedItem());
  }

  public void addActionListener( ActionListener a )
  {
    elementalComboBox.addActionListener(a);
    matrixComboBox.addActionListener(a);
    vectorComboBox.addActionListener(a);
  }

}